<template>
  <v-form @submit.prevent="editUser">
    <v-container>
      <v-row>
        <v-col>
          <h2 v-if="authStore.user.userId !== user.userId">Mitarbeiter ({{user.userId}}) bearbeiten</h2>
          <h2 v-else>Meine Daten bearbeiten.</h2>

          <v-text-field
              v-model="userToEdit.email"
              label="E-Mail">
          </v-text-field>

          <v-text-field
              v-model="userToEdit.firstName"
              label="Vorname">
          </v-text-field>

          <v-text-field
              v-model.number="userToEdit.lastName"
              label="Nachname">
          </v-text-field>

          <v-text-field
              type="date"
              v-model="userToEdit.birthday"
              label="Geburtsdatum">
          </v-text-field>

          <v-select
              v-show="authStore.user.role === 'ADMIN'"
              label="Rolle"
              :items="['ADMIN', 'MANAGER', 'USER']"
              v-model="userToEdit.role"
          ></v-select>

          <v-select
              v-show="authStore.user.role === 'ADMIN'"
              label="Abteilung"
              :items="departments"
              v-model="userToEdit.department"
          ></v-select>

<!--          <v-select
              v-if="userToEdit.role === 'MANAGER'"
              label="Geleitete Abteilung"
              :items="departments"
              v-model="userToEdit.managedDepartment"
          ></v-select>-->

          <v-btn
              color="green-darken-3"
              block
              class="me-4"
              type="submit">Bestätigen</v-btn>

        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script setup>
import {computed, onMounted, ref, toRaw, watch} from "vue";
import {useUserStore} from "@/stores/userStore";
import {useAuthStore} from "@/stores/authStore";
import {useDepartmentStore} from "@/stores/departmentStore";

//STORES
const userStore = useUserStore();
const departmentStore = useDepartmentStore();
const authStore = useAuthStore();

//PROPS & EMITS
const emit = defineEmits(['dialog']);
const props = defineProps(["user", "page"]);

//VARIABLES
const dialog = ref(false);
const departments = computed(() => toRaw(departmentStore.departments));
const departmentsLoaded = ref(false);
const userToEdit = ref({
  email: "",
  firstName: "",
  lastName: "",
  birthday: "",
  role: "",
  department: "",
  managedDepartment: ""
});

//LIFECYCLEHOOK
onMounted(async () => {
  await departmentStore.getDepartments();
})

//WATCHER
watch(() => props.user, (newUser) => {
  if (newUser) {
    userToEdit.value.email = newUser.email;
    userToEdit.value.firstName = newUser.firstName;
    userToEdit.value.lastName = newUser.lastName;
    userToEdit.value.birthday = newUser.birthday;
    userToEdit.value.role = newUser.role;
    userToEdit.value.department = newUser.department;
  }
}, { immediate: true });

//FUNCTIONS
async function editUser() {
  try {
    if (userToEdit.value.role === 'MANAGER') {
      userToEdit.value.managedDepartment = userToEdit.value.department;
      emit('dialog')
      await userStore.editUser(props.user.userId, userToEdit.value);
      await authStore.checkIfLoggedIn();
      await userStore.getUsers(props.page);
    } else {
      userToEdit.value.role = authStore.user.role;
      userToEdit.value.department = authStore.user.department;
      if (userToEdit.value.email.length > 0 &&
          userToEdit.value.firstName.length > 0 &&
          userToEdit.value.lastName.length > 0 &&
          userToEdit.value.birthday.length > 0 &&
          userToEdit.value.role.length > 0 &&
          userToEdit.value.department.length > 0) {
        emit('dialog')
        await userStore.editUser(props.user.userId, userToEdit.value);
        await authStore.checkIfLoggedIn();
        await userStore.getUsers(props.page)

      } else {
        alert("Bitte fülle alle Felder aus.")
      }
    }
  }catch (error) {
    console.log("error", error)
    alert("Diese Abteilung hat bereits einen Abteilungsleiter.")
  }
}
</script>

<style scoped>
</style>